<template>
  <div>
    <div data-vjs-player>
      <video ref="videoNode" class="video-js vjs-default-skin vjs-big-play-centered">抱歉，您的浏览器不支持</video>
    </div>
  </div>
</template>

<script>
import videojs from 'video.js'
import 'video.js/dist/video-js.css'

export default {
  name: 'VideoPlayer',
  props: {
    src: {
      type: String,
      default: () => ''
    },
    controls: {
      type: Boolean,
      default: () => true
    }
  },
  data() {
    return {
      player: null
    }
  },
  watch: {
    src: {
      handler(val, oldVal) {
        if (val === oldVal) {
          return false
        }
        if (this.player) {
          this.loading = true // 重新显示加载状态
          const myPlayer = this.player
          myPlayer.off('timeupdate') // 清空时间
          myPlayer.reset() // 重置播放器
          myPlayer.pause() // 暂停播放
          myPlayer.src([ // 重新设置播放源
            {
              src: this.src,
              type: 'video/mp4'
            }
          ])
          myPlayer.load(this.src) // 重新加载视频
          myPlayer.play() // 播放视频
          myPlayer.one('playing', function() {
            // 加载完成，开始播放
            this.loading = false // 隐藏加载状态
          })
        }
      }
    }
  },
  mounted() {
    // 初始化播放器
    const options = {
      autoplay: true, // 自动播放
      controls: this.controls, // 控制条
      preload: 'auto', // 自动加载
      errorDisplay: true, // 错误展示
      // fluid: true, // 跟随外层容器变化大小，跟随的是外层宽度
      width: 864, // 视频的宽度
      height: 486, // 视频的高度
      aspectRatio: '16:9', // 视频的宽高比
      // controlBar: false, // 设为false不渲染控制条DOM元素，只设置controls为false虽然不展示，但是存在
      // textTrackDisplay: false, // 不渲染字幕相关DOM
      userActions: {
        hotkeys: true // 是否支持热键
      },
      notSupportedMessage: '此视频暂无法播放，请稍后再试',
      sources: [
        {
          src: this.src,
          // type: 'rtmp/flv',
          type: 'video/mp4'
        }
      ]
    }
    this.player = videojs(
      this.$refs.videoNode,
      options,
      function onPlayerReady() {
        videojs.log('Your player is ready!')
      }
    )
  },
  beforeDestroy() {
    if (this.player) {
      this.player.dispose()
    }
  }
}
</script>
